<template>
  <li
    :class="{
      'm-comments__item--compact': !isVisible,
      'm-comments__item--haschildren': isDeletedAndHasChildren,
    }"
  >
    <div class="m-comments__user">
      <template v-if="isDeletedAndHasChildren">
        <div class="m-comments__user-title" @click="onToggleVisibility">
          <i
            :class="{
              'el-icon-caret-right': !isVisible,
              'el-icon-caret-bottom': isVisible,
            }"
          />
          Комментарий удален мурреном
        </div>
      </template>

      <template v-else-if="isDeleted">
        <div class="m-comments__user-title">Комментарий удален мурреном</div>
      </template>

      <template v-else>
        <div
          v-show="isVisible"
          @click="goProfile"
          class="m-comments__user-avatar"
        >
          <img :src="comment.author_avatar" :alt="comment.author_username" />
        </div>

        <div v-if="isVisible" @click="goProfile" class="m-comments__user-name">
          {{ comment.author_username }}
        </div>
        <div v-else @click="onToggleVisibility" class="m-comments__user-name">
          <i class="el-icon-circle-plus-outline" />
          {{ comment.author_username }}
        </div>

        <div class="m-comments__user-added">
          муррчит {{ comment.created | dateFormatHumanDiff }}
        </div>
      </template>

      <div
        class="m-comments__user-replies"
        v-if="isDeletedAndHasChildren || (!isVisible && hasChildren)"
      >
        внутри {{ replies }} ответа
      </div>
    </div>

    <div v-show="isVisible">
      <template v-if="!isDeleted">
        <compact-text
          class="m-comments__body"
          body-class="m-comments__body-text"
          :markdown="true"
          :text="comment.text"
        />

        <div class="m-comments__actions">
          <el-button
            v-if="isMurrenAuthorized"
            type="text"
            size="mini"
            icon="el-icon-s-comment"
            class="m-comments__actions-item reply"
            @click="onToggleReplyForm"
            v-text="!isShowReply ? 'ответить' : 'скрыть'"
          />

          <el-button
            type="text"
            size="mini"
            icon="el-icon-arrow-up"
            :class="{ 'is-liked': comment.is_like }"
            class="m-comments__actions-item m-comments__rating-button"
            @click="onLikeComment"
          />

          <el-button
            type="text"
            size="mini"
            class="m-comments__actions-item m-comments__rating-counter"
            :class="{
              positive: comment.rating > 0,
              negative: comment.rating < 0,
            }"
            v-text="comment.rating"
          />

          <el-button
            type="text"
            size="mini"
            icon="el-icon-arrow-down"
            :class="{ 'is-disliked': comment.is_dislike }"
            class="m-comments__actions-item m-comments__rating-button"
            @click="onDislikeComment"
          />

          <comment-menu v-if="isAuthored" @delete-comment="onDeleteComment" />
        </div>

        <comment-form-user
          v-if="isShowReplyAndAuthorized"
          :focus-after-show="true"
          :murren="currentMurren"
          @create-comment="onAddComment"
          ref="form"
          class="m-comments-form--children"
        />
      </template>

      <ul
        class="m-comments__list m-comments__list--children"
        v-if="hasChildren"
        ref="comments"
      >
        <comments-item
          v-for="children in comment.children"
          :key="children.id"
          :comment="children"
          class="m-comments__item m-comments__item--children"
        />
      </ul>

      <div class="m-comments__toggle-visibility" @click="onToggleVisibility" />
    </div>
  </li>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import eventEmitter from "../../../utils/EventEmitter.js";

import {
  ACTIONS_REPLY_COMMENT,
  ACTIONS_DELETE_COMMENT,
  ACTIONS_LIKE,
  ACTIONS_DISLIKE,
} from "../store/type.js";

import CommentFormUser from "../components/CommentFormUser.vue";
import CompactText from "../../common/CompactText.vue";
import CommentMenu from "./CommentMenu.vue";

export default {
  name: "CommentsItem",

  components: {
    CommentFormUser,
    CompactText,
    CommentMenu,
  },

  props: {
    comment: {
      required: true,
      type: Object,
    },
  },

  created() {
    // Subscribe to the event closing all forms
    eventEmitter.$on("comment-hide-forms", (commentId) => {
      if (this.isShowReply && commentId !== this.comment.id) {
        this.isShowReply = false;
      }
    });

    this.isVisible = !this.isDeletedAndHasChildren;
  },

  data() {
    return {
      isShowReply: false,
      isVisible: true,
    };
  },

  methods: {
    ...mapActions({
      notification: "popUpMessage",
    }),

    onToggleVisibility() {
      this.isVisible = !this.isVisible;
    },

    onToggleReplyForm() {
      this.isShowReply = !this.isShowReply;
    },

    async onAddComment({ text, recaptchaToken }) {
      const newComment = await this.$store.dispatch(ACTIONS_REPLY_COMMENT, {
        text,
        recaptchaToken,
        murrId: this.comment.murr,
        parent: this.comment.id,
      });

      if (newComment) {
        this.comment.children = [newComment, ...this.comment.children];

        this.$refs.form.resetFormState();
        this.isShowReply = false;

        this.$nextTick(() => {
          this.$refs.comments.scrollIntoView({
            block: "center",
            behavior: "smooth",
          });
        });
      }
    },

    async onDeleteComment() {
      const result = await this.$store.dispatch(
        ACTIONS_DELETE_COMMENT,
        this.comment.id
      );

      if (result) {
        this.comment.deleted = Date.now().toString();
        this.isVisible = false;

        this.notification({
          message: result.message,
          type: result.success ? "success" : "error",
        });
      }
    },

    async onLikeComment() {
      if (!this.isMurrenAuthorized) {
        return this.showMessageGuest();
      }
      const result = await this.$store.dispatch(ACTIONS_LIKE, {
        commentId: this.comment.id,
      });
      if (result) {
        this.updateFields(result);
      }
    },

    async onDislikeComment() {
      if (!this.isMurrenAuthorized) {
        return this.showMessageGuest();
      }
      const result = await this.$store.dispatch(ACTIONS_DISLIKE, {
        commentId: this.comment.id,
      });
      if (result) {
        this.updateFields(result);
      }
    },

    showMessageGuest() {
      return this.$store.dispatch("popUpMessage", {
        message: "Требуется авторизация 😳",
        customClass: "element-ui-message__warning",
        type: "warning",
      });
    },

    updateFields(values) {
      const UPDATE_FIELDS = ["rating", "is_like", "is_dislike"];
      UPDATE_FIELDS.forEach((filed) => {
        this.comment[filed] = values[filed];
      });
    },

    async goProfile() {
      await this.$router.push({
        name: "murren",
        params: { murren_name: this.comment.author_username },
      });

      this.$store.commit("modal/close");
    },
  },

  computed: {
    ...mapGetters({
      currentMurren: "currentMurren",
      isMurrenAuthorized: "isMurrenAuthorized",
    }),

    isAuthored() {
      if (!this.isMurrenAuthorized) return false;
      return this.currentMurren.id === this.comment.author;
    },

    replies() {
      return this.comment.children.length;
    },

    hasChildren() {
      return this.replies > 0;
    },

    isDeleted() {
      return !!this.comment.deleted;
    },

    isDeletedAndHasChildren() {
      return this.isDeleted && this.hasChildren;
    },

    isShowReplyAndAuthorized() {
      return this.isShowReply && this.isMurrenAuthorized;
    },
  },

  watch: {
    isShowReplyAndAuthorized(_, oldValue) {
      if (oldValue) return;
      // Send an event to all forms so that they close if open
      eventEmitter.$emit("comment-hide-forms", this.comment.id);
    },
  },
};
</script>
